#!/usr/local/bin/perl
$jumpfile = "";     # DON'T modify this line
$jumptime    = 0;   # DON'T modify this line
$mode = "silent";   # DON'T modify this line
# ---------------------------------------------------------------------------
#    Copyright(C) 1997,1999-2000 IIZUKA,Shinji(siizuka@nurs.or.jp)
#
#    randurl.cgi - Junp to random url
#
# ----------------------------------------------------------------------*/
#  history:								*
# 	1997.12.18	v1	created(for beta release)		*
# 	1999.09.21	v1.1	disable cache of the browser		*
# 	2000.01.25	v2	Apply "silent" mode			*
# ----------------------------------------------------------------------*/

# ---------------------------------------------------------------------------
# APPLICATION:
# * make URL file, including all URLs (one URL per one line, and only URL in
#   the file) to jump.
#   default filename is "url.txt".
# * You may have to modify following lines to aplly this to your environment.
# * Using view mode, this script can display your html file before jumping.

# change "url.txt" in following line into adequate file name 
# which contains URLs you want the browser to jump.
$urlfile = "url.txt";

# Uncomment adequate line to decide jump mode. 
$mode = "silent";       # Jump using response(302).
                                # Using this mode, browser displays
                                # no html and jump immediately.
# $mode = "view";       # Jump using META tags.
                                # Using this mode, browser first displays
                                # message and jump.


#
# Uncomment following line and change "your.html" into a html file
# you want to display before jumping.
# This option is aviable only in VIEW mode.
# Warning: "META EQUIV=..." tags cannot be contained in this HTML file.

# $jumpfile = "your.html";

# Uncomment following line and change "0" into the time(second)
# from a browser displays jumping message until jump starts.
# This option is aviable only in VIEW mode.

# $jumptime = 0;

# ---------------------------------------------------------------------------
# Main routine
# ---------------------------------------------------------------------------
$ix      = 0;

open( STDERR, ">&STDOUT" );

&get_parm;

SWITCH: { 
	if ( uc($FORM{'MODE'}) eq "VIEW"    ) { $mode = "view"  ; last SWITCH; }
	if ( uc($FORM{'MODE'}) eq "SILENT"  ) { $mode = "silent"; last SWITCH; }
}

# read all URLs
open ( IN, "<$urlfile") || do { &on_error();exit(0); };
while(<IN>) {
	$_ =~ s/\n//g;
	$ar_url[$ix] = $_;
	$ix++;
}
close(IN);

# output HTML
srand();
$r = int(rand($ix + 1 ));
if ( $r > $ix ) {
	$r = $ix; 
}

$url_to_jump = $ar_url[$r];

if ( $mode eq "view" ) {
	$jumpfile = $FORM{'JUMPFILE'} if ( $FORM{'JUMPFILE'} ne "" );
	$jumptime = 0 + $FORM{'JUMPTIME'} if ( $FORM{'JUMPTIME'} >  0  );

	if ( $jumpfile ne "" ) {
		&view_and_jump;
	} else {
		&view_default_and_jump;
	}
} else {
	print "Location: $url_to_jump\n\n";
}

exit( 0 );

# ----------------------------------------------------------------------
sub get_parm {
# ----------------------------------------------------------------------
	if (uc($ENV{'REQUEST_METHOD'}) eq 'POST') {
		read(STDIN, $buffer, $ENV{'CONTENT_LENGTH'});
	} elsif ( uc($ENV{'REQUEST_METHOD'}) eq 'GET') {
		$buffer = $ENV{'QUERY_STRING'};
	} else {
		$buffer = "";
	}
	@pairs = split(/&/,$buffer);
	$ix = 0;

	foreach $pair (@pairs) {
		($name, $value) = split(/=/, $pair);
		$name  =~ tr/[a-z]/[A-Z]/;
		$FORM{$name} = $value;
	}
};


# ----------------------------------------------------------------------
sub view_and_jump {
# ----------------------------------------------------------------------
	&check_filename( $jumpfile );
	open( HTML, "<$jumpfile" ) || do { &view_default_and_jump; return; };

	print "Content-type: text/html\n\n";
	$jump_done = 0;
	while(<HTML>) {
		if ( $jump_done == 0 && $_ =~ /\< *[Bb][Oo][Dd][Yy]\.*>?/ ) {
			print "<HTML>\n";
			print "<HEAD>\n";
			print "    <META HTTP-EQUIV=\"Pragma\" CONTENT=\"no-cache\">\n";
			print "    <META HTTP-EQUIV=\"Refresh\" CONTENT=\"$jumptime;URL=$url_to_jump\">\n";
			print "</HEAD>\n";
			$jump_done = 1;
		}
		print $_;
		if ( $jump_done == 0 && $_ =~ /\< *[Hh][Ee][Aa][Dd]\ *>/ ) {
			print "<META HTTP-EQUIV=\"Pragma\" CONTENT=\"no-cache\">\n";
			print "<META HTTP-EQUIV=\"Refresh\" CONTENT=\"$jumptime;URL=$url_to_jump\">\n";
			$jump_done = 1;
		}

	}
	close(HTML);
};

# ----------------------------------------------------------------------
sub view_default_and_jump {
# ----------------------------------------------------------------------
	print "Content-type: text/html\n\n";
	print "<HTML>\n";
	print "<META HTTP-EQUIV=\"Pragma\" CONTENT=\"no-cache\">";
	print "<META HTTP-EQUIV=\"Refresh\" CONTENT=\"$jumptime;URL=$url_to_jump\">";
	print "<BODY>Now jumping... <BR>";
	print "Click <A HREF=$url_to_jump>HERE</A> if failed to jump.</BODY>\n";
	print "</HTML>\n";
};

# ----------------------------------------------------------------------
sub on_error {
# ----------------------------------------------------------------------
	print "Content-type: text/html\n\n";
	print "<HTML><BODY>\n";
	print "Sorry, I cannot jump.Please back to previor page using back function of your browser.\n";
	print "</BODY></HTML>\n";
};

# ----------------------------------------------------------------------
sub check_filename {
# ----------------------------------------------------------------------
	$parent_cnt = 0;
	@file_tokens = split(/\//, $_[0]);
	foreach $element (@file_tokens) {
		do { $_[0] = ""; return; } if ( $element eq '' );

		$parent_cnt ++             if ( $element eq '..' );
		do { $_[0] = ""; return; } if ( $parent_cnt >= 2 );
		$last_element = $element;
	}
	if ( lc($last_element) =~ /\.html$/ ||
	     lc($last_element) =~ /\.htm$/ ) {
		# no statement 
	} else {
		$_[0] = ""; return;
	}
}
